package com.fr.plugin.decision.transmission.decrypt;

import com.fr.base.Base64;
import com.fr.base.ServerConfig;
import com.fr.decision.fun.impl.AbstractTransmissionEncryptionProvider;
import com.fr.decision.web.CommonComponent;
import com.fr.log.FineLoggerFactory;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.stable.StringUtils;
import com.fr.web.struct.Atom;

/**
 * @author Zed
 * @version 10.0
 * Created by Zed on 2020/2/11
 */
@FunctionRecorder
public class Base64Encryption extends AbstractTransmissionEncryptionProvider {

    @Override
    public String decrypt(String encryptionInfo) {
        try {
            if (StringUtils.isNotEmpty(encryptionInfo)) {
                return new String(Base64.decode(encryptionInfo), ServerConfig.getInstance().getServerCharset());
            }
        } catch (Exception e) {
            FineLoggerFactory.getLogger().error(e.getMessage(), e);
        }

        return StringUtils.EMPTY;
    }

    @Override
    public Atom attach() {
        return CommonComponent.KEY;
    }

    @Override
    public Atom client() {
        return Base64Component.KEY;
    }

    @Override
    public String encrypt(String plainInfo) {
        try {
            if (StringUtils.isNotEmpty(plainInfo)) {
                return Base64.encode(plainInfo.getBytes(ServerConfig.getInstance().getServerCharset()));
            }
        } catch (Exception e) {
            FineLoggerFactory.getLogger().error(e.getMessage(), e);
        }
        return StringUtils.EMPTY;
    }
}
